unit Prman_u;
{**************************************************************************

  Delphi-Project-Starter

  Opens Delphi a Delphi project and it's according Component Library

  Author: Hannes Danzl (e9026733@stud3.tuwien.ac.at)

  FREEWARE

  If you change it, please send me a copy!!

************************************************************************** }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, IniFiles, Menus, DB,
  DBTables, DBCtrls, Mask, regi1632, user, Grids, DBGrids, DBLookup;

type
  EIniList = class(exception);

  THDProjectStarter = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    MainMenu1: TMainMenu;
    Konfiguration1: TMenuItem;
    DelphiPfad1: TMenuItem;
    DelphiIniDatei1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Table1: TTable;
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    Delphi101: TMenuItem;
    Delphi102: TMenuItem;
    Path1: TMenuItem;
    Import1: TMenuItem;
    Version101: TMenuItem;
    Table2: TTable;
    OpenDialog2: TOpenDialog;
    GetCurrentConfig1: TMenuItem;
    CurrentDelphi10Config1: TMenuItem;
    CurrentDelphi20Config1: TMenuItem;
    Export1: TMenuItem;
    ProjectConfiguration1: TMenuItem;
    SaveDialog1: TSaveDialog;
    UserData1: TMenuItem;
    Label3: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    thename: TDBEdit;
    Label2: TLabel;
    dpr: TDBEdit;
    Version: TDBRadioGroup;
    Button1: TButton;
    DBMemo1: TDBMemo;
    Label7: TLabel;
    regfiles: TMemo;
    Label6: TLabel;
    dclpfad: TDBMemo;
    Label5: TLabel;
    dcl: TDBEdit;
    Label4: TLabel;
    Button3: TButton;
    GroupBox1: TGroupBox;
    dbtarget10: TDBCheckBox;
    dbtarget20: TDBCheckBox;
    Table3: TTable;
    ListBox1: TListBox;
    Label8: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure DelphiPfad1Click(Sender: TObject);
    procedure DelphiIniDatei1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Path1Click(Sender: TObject);
    procedure Version101Click(Sender: TObject);
    procedure CurrentDelphi10Config1Click(Sender: TObject);
    procedure CurrentDelphi20Config1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure ProjectConfiguration1Click(Sender: TObject);
    procedure UserData1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    DelphiExe:String;
    DelphiINI:String;
    Delphi32Exe:String;
    IsLoaded:Boolean;
    procedure OpenDelphi1;
    procedure OpenDelphi2;
    function FindRecordNumber: Longint;
    function  GotoProgram(aname:string):boolean;
    procedure FillListbox;
  public
    { Public-Deklarationen }
  end;

var HDProjectStarter:THDProjectStarter;

implementation

{$R *.DFM}

uses DBiProcs, DBiTypes;

procedure THDProjectStarter.FormCreate(Sender: TObject);
var TheIniFile:TIniFile;
    aregistry:TRegistry1632;
    text:string;
begin
  { get configuration }
  IsLoaded:=false;

  TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
  delphiexe:=theInifile.readstring('Konfiguration','DelphiEXE','');
  delphiINI:=theInifile.readstring('Konfiguration','DelphiINI','');
  delphi32exe:=theInifile.readstring('Konfiguration','Delphi32EXE','');
  { open table and move to last saved position - only if there are records }
  table1.tablename:=extractfilepath(paramstr(0))+'prmanag.db';
  table1.addindex('NameIndex','programmname',[ixPrimary]);
  table1.active:=true;
  table1.first;
  if table1.recordcount>0 then
    table1.moveby(theIniFile.readinteger('Settings','LastDataRecord',1)-1);
  TheIniFile.free;
  FillListbox;
end;

procedure THDProjectStarter.FillListbox;
begin
  table3.tablename:=table1.tablename;
  table3.active:=true;
  table3.first;
  sendmessage(listbox1.handle,wm_setredraw, word(false),0);
  listbox1.clear;
  repeat
    listbox1.items.add(table3.findfield('programmname').asstring);
    table3.next;
  until table3.eof;
  table3.active:=false;
  listbox1.itemindex:=listbox1.items.indexof(thename.text);
  sendmessage(listbox1.handle,wm_setredraw, word(true),0);
  listbox1.refresh;
end;

procedure THDProjectStarter.DelphiPfad1Click(Sender: TObject);
var TheIniFile:TIniFile;
begin
  { change Delphi 1.0 filename }
  if delphiEXE<>'' then
    opendialog1.filename:=delphiexe;
  opendialog1.filterindex:=1;
  if opendialog1.execute then
  begin
    delphiexe:=opendialog1.fileName;
    TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
    theInifile.writestring('Konfiguration','DelphiEXE',delphiexe);
    TheIniFile.Free;
  end;
end;

procedure THDProjectStarter.DelphiIniDatei1Click(Sender: TObject);
var TheIniFile:TIniFile;
begin
  { change Delphi 1.0 ini-filename }
  if delphiINI<>'' then
    opendialog1.filename:=delphiINI;
  opendialog1.filterindex:=2;
  if opendialog1.execute then
  begin
    delphiINI:=opendialog1.fileName;
    TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
    theInifile.writestring('Konfiguration','DelphiINI',delphiINI);
    TheIniFile.Free;
  end;
end;

procedure THDProjectStarter.Button1Click(Sender: TObject);
begin
  { get project filename }
  opendialog1.filterindex:=4;
  opendialog1.fileName:='';
  if opendialog1.execute then
  begin
    table1.edit;
    dpr.text:=opendialog1.fileName;
    table1.post;
  end;
end;

procedure THDProjectStarter.Button3Click(Sender: TObject);
begin
  { get library filename }
  opendialog1.filterindex:=3;
  opendialog1.fileName:='';
  if opendialog1.execute then
  begin
    table1.edit;
    dcl.text:=opendialog1.fileName;
    table1.post;
  end;
end;

procedure THDProjectStarter.Opendelphi2;
var pdelphiexe:array[0..256] of char;
    aregistry:TRegistry1632;
begin
  { write settings to registry and start delphi 2.0 }
  if fileexists(delphi32exe) then
  begin
    aregistry:=Tregistry1632.Create;

    aregistry.WriteUserString('Software\Borland\Delphi\2.0\Session\','Project', dpr.text);
    aregistry.WriteUserString('Software\Borland\Delphi\2.0\Library\','ComponentLibrary',dcl.text);
    aregistry.WriteUserString('Software\Borland\Delphi\2.0\Library\','SearchPath', dclpfad.text);

    if aregistry.runningwin31 then
      messagedlg('Delphi 2.0 cannot be started in Windows 3.x',mterror,[mbok],0)
    else
    begin
      strpcopy(pdelphiexe,delphi32exe);
      winexec(pdelphiexe,sw_show);
    end;
    aregistry.free;
  end
  else
    messagedlg('Please check the settings for correct filenames!',mterror,[mbok],0);
end;

procedure THDProjectStarter.OpenDelphi1;
var delphiIniFile:TIniFile;
    pdelphiexe:array[0..256] of char;
    DelphiHandle:Word;
    Seconds:LongInt;
begin
  { write settings to ini-file and start delphi 1.0 }
  if fileexists(delphiINI) and fileexists(delphiexe) then
  begin
    { close Delphi, if it is running }
    DelphiHandle:=FindWindow('TApplication','Delphi');
    if DelphiHandle<>0 then
      SendMessage(DelphiHandle,wm_close,0,0);
    seconds:=GettickCount;
    repeat
      Application.ProcessMessages;
    until seconds+2000<GettickCount;

    delphiIniFile:=TIniFile.Create(delphiIni);
    delphiIniFile.WriteString('Library','SearchPath',dclpfad.text);
    delphiIniFile.WriteString('Library','ComponentLibrary',dcl.text);
    delphiIniFile.WriteString('Session','Project',dpr.text);

    strpcopy(pdelphiexe,delphiexe);
    winexec(pdelphiexe,sw_show);
    delphiIniFile.Free;
  end
  else
    messagedlg('Please check the settings for correct filenames!',mterror,[mbok],0);
end;

procedure THDProjectStarter.BitBtn1Click(Sender: TObject);
begin
  if (table1.state=dsEdit) then
    table1.post;
  { starts delphi 1.0 or 2.0 }
  if version.value='Delphi 1.0' then
    opendelphi1
  else
  if version.value='Delphi 2.0' then
    opendelphi2;
end;

procedure THDProjectStarter.Path1Click(Sender: TObject);
var TheIniFile:TIniFile;
begin                              
  { set Delphi 2.0 filename }
  if delphi32EXE<>'' then
    opendialog1.filename:=delphi32exe;
  opendialog1.filterindex:=1;
  if opendialog1.execute then
  begin
    delphi32exe:=opendialog1.fileName;
    TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
    theInifile.writestring('Konfiguration','Delphi32EXE',delphi32exe);
    TheIniFile.Free;
  end;
end;

procedure THDProjectStarter.Version101Click(Sender: TObject);
begin
  { import Data from Version 1.0 since the database was changed! }
  if opendialog2.execute then
    if fileexists(opendialog2.filename) then
    begin
      table2.tablename:=opendialog2.filename;
      table2.active:=true;
      table2.first;
      while not table2.eof do
      begin
        table1.append;
        table1.findfield('programmname').asstring:=table2.findfield('programmname').asstring;
        tmemofield(table1.findField('beschreibung')).assign(tmemofield(table2.findfield('beschreibung')));
        table1.findfield('DPR-Datei').asstring:=table2.findfield('DPR-Datei').asstring;
        table1.findfield('DCL-Datei').asstring:=table2.findfield('DCL-Datei').asstring;
        table1.findfield('DCL-Pfad').asstring:=table2.findfield('DCL-Pfad').asstring;
        table1.post;
        table2.next;
      end;
      table2.close;
      table1.first;
    end;
end;

procedure THDProjectStarter.CurrentDelphi10Config1Click(Sender: TObject);
var delphiIniFile:TIniFile;
begin
  { get current delphi 1.0 configuration }
  if fileexists(delphiINI) then
  begin
    delphiIniFile:=TIniFile.Create(delphiIni);
    table1.Append;
    theName.Text:='Current Delphi 1.0 Config';
    dclpfad.text:=delphiIniFile.ReadString('Library','SearchPath','');
    dcl.text:=delphiIniFile.ReadString('Library','ComponentLibrary','');
    dpr.text:=delphiIniFile.ReadString('Session','Project','');
    dbMemo1.lines.add('Automatically added on '+datetostr(sysutils.date) + ' ' + timetostr(sysutils.time));
    Version.Value:='Delphi 1.0';
    table1.post;
    table1.last;
    delphiIniFile.Free;
  end
  else
    messagedlg('Please check the settings for correct filenames!',mterror,[mbok],0);
end;

procedure THDProjectStarter.CurrentDelphi20Config1Click(Sender: TObject);
var delphiIniFile:TIniFile;
    result:longint;
    atext:array[0..256] of char;
    alength:LongInt;
    aregistry:TRegistry1632;
begin
  { get current delphi 2.0 configuration }
  table1.Append;

  theName.Text:='Current Delphi 2.0 Config';
  aregistry:=TRegistry1632.Create;

  dpr.text:=aregistry.ReadUserString('Software\Borland\Delphi\2.0\Session\','Project');
  dcl.text:=aregistry.ReadUserString('Software\Borland\Delphi\2.0\Library\','ComponentLibrary');
  dclpfad.text:=aregistry.ReadUserString('Software\Borland\Delphi\2.0\Library\','SearchPath');
  aregistry.free;

  dbMemo1.lines.add('Automatically added on '+datetostr(sysutils.date) + ' ' + timetostr(sysutils.time));
  Version.Value:='Delphi 2.0';
  table1.post;
  table1.last;
end;

function THDProjectStarter.FindRecordNumber: Longint;
var
  cP: CurProps;
  rP: RECProps;
  FDataLink:TDataLink;
begin
  { method to find record number }
  Result := 0;
  if table1.recordcount<1 then
    exit;

  FDataLink := TFieldDataLink.Create;
  FDataLink.DataSource := DataSource1;

  with FDataLink.DataSource.Dataset do
  begin
    {we need to make this call to grab the cursor's iSeqNums}
    Check(DBiGetCursorProps(Handle,cP));
    {synchronize the BDE cursor with the dataset's cursor}
    UpdateCursorPos;
    {fill rP with the current record's properties}
    Check(DBiGetRecord(Handle,DBiNOLOCK,nil,@rP));
    {what kind of dataset are we looking at?}
    case cP.iSeqNums of
      0: Result := rP.iPhyRecNum; {dBase}
      1: Result := rP.iSeqNum;    {Paradox}
    end;
  end;

  FDataLink.Free;
end;

procedure THDProjectStarter.FormClose(Sender: TObject; var Action: TCloseAction);
var theIniFile:TIniFile;
begin
  if (table1.state=dsEdit) then
    table1.post;
  { write the current RecordNumber to Ini-File }
  TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
  theInifile.writeinteger('Settings','LastDataRecord',findrecordNumber);
  TheIniFile.Free;
end;

function THDProjectStarter.GotoProgram(aname:string):boolean;
begin
  result:=false;
  table1.first;
  while (not table1.eof) and (result=false) do
  begin
    if uppercase(table1.findfield('DPR-Datei').asstring)=uppercase(aname) then
      result:=true
    else
      table1.next;
  end;
end;

procedure THDProjectStarter.DataSource1DataChange(Sender: TObject;
  Field: TField);
var fileName:string;
    kennung:array[0..2] of char;
    hipos,lopos:byte;
    thepos:word;
    files:String;
    f:integer;
    aresult:word;
begin
  if (field=nil) and (not (csloading in ComponentState)) then
  begin
    isloaded:=true;
    fillListbox;
    filename:=dcl.text;
    if fileexists(filename) then
    begin
      f:=0;
      f:=fileOpen(filename, of_read + of_share_compat);
      if f<1 then
        exit;

      files:='';
      regfiles.text:='';

      fileread(f,kennung,3);

      if strlcomp(kennung,'MZP',3)=0 then
      begin
        regfiles.text:='Currently not  supported for 32-Bit DCL';
      end
      else
      begin
        fileseek(f,$12c,0);
        fileread(f,thepos,2);
        if lobyte(thepos)>242 then
          thepos:=hibyte(thepos)*256+$203
        else
          thepos:=hibyte(thepos)*256+$103;
        if fileseek(f,thepos,0)<>thepos then
          exit;
        repeat
          if fileread(f,lopos,1)<>1 then
            exit;
          if (lopos<>$9a) and (lopos>$10) then
            files:=files+char(lopos);
          if (lopos<$10) or (length(files)>200) then
          begin
            if regfiles.text<>'' then
              regfiles.text:=regfiles.text+', '+ files
            else
              regfiles.text:=files;
            files:='';
          end;
        until lopos=$9a;
      end;
      fileclose(f);
    end;
    isloaded:=false;
  end;
end;

procedure THDProjectStarter.ProjectConfiguration1Click(Sender: TObject);
var a:longint;
    f:TextFile;
    TheIniFile:TIniFile;
begin
  savedialog1.initialdir:=extractfilepath(dpr.text);
  savedialog1.filename:=changefileext(extractfilename(dpr.text),'.inf');
  if savedialog1.execute then
  begin
    assignfile(f, savedialog1.filename);
    rewrite(f);
    writeln (f,'');
    writeln (f, 'Project Info:');
    writeln (f, '-------------');
    writeln (f, 'Projectname: '+thename.text);
    write (f, 'Target     : ');
    if (dbtarget10.checked) and (dbtarget20.checked) then
      writeln(f,'Delphi 1.0, Delphi 2.0')
    else if dbtarget10.checked then
      writeln(f,'Delphi 1.0')
    else if dbtarget20.checked then
      writeln(f,'Delphi 2.0')
    else
      writeln(f,'Not known');

    TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
    if TheIniFile.readstring('UserData','Name','') <>'' then
    begin
      writeln (f, 'Author     : '+TheIniFile.readstring('UserData','Name',''));
      if TheIniFile.readstring('UserData','E-mail','') <>'' then
        writeln (f, '  E-Mail   : '+TheIniFile.readstring('UserData','E-Mail',''));
    end;
    TheIniFile.Free;

    writeln (f,'');
    writeln (f, 'Description:');
    writeln (f, '------------');
    for a:=0 to dbmemo1.lines.count-1 do
      writeln(f, dbmemo1.lines[a]);
    writeln (f,'');
    writeln (f,'How to use it:');
    writeln (f,'--------------');
    writeln (f,'Project File Name: '+ extractfilename(dpr.text));
    writeln (f,'Component Library: '+ extractfilename(dcl.text));
    writeln (f,'  Used Reg-Files : '+regfiles.text);
    writeln (f,'  Searchpath     : '+dclpfad.text);
    writeln (f,'');
    writeln (f,'');
    writeln (f,'');
    writeln (f,'(Project Information File created by Delphi Project Manager V1.2)');
    closefile(f);
  end;
end;

procedure THDProjectStarter.UserData1Click(Sender: TObject);
var TheIniFile:TIniFile;
    dlgUserSettings:TdlgUserSettings;
begin
  dlgUserSettings:=TdlgUserSettings.create(self);
  TheIniFile:=TIniFile.Create(extractfilepath(paramstr(0))+'prmanag.ini');
  dlgUserSettings.edit1.text:=theinifile.readstring('UserData','Name','');
  dlgUserSettings.edit2.text:=theinifile.readstring('UserData','E-Mail','');
  if dlgUserSettings.showmodal=mrok then
  begin
    theinifile.writestring('UserData','Name',dlgUserSettings.edit1.text);
    theinifile.writestring('UserData','E-Mail',dlgUserSettings.edit2.text);
  end;
  dlgUserSettings.free;
  TheIniFile.free;
end;

procedure THDProjectStarter.ListBox1Click(Sender: TObject);
var key:string;
begin
  key:=listbox1.items[listbox1.itemindex];
  table1.findkey([key]);
end;

end.


